Add piwik tracking code to startpage.html
[grml-live.git] / grml-live
index 8ec8348..83ef125 100755 (executable)
--- a/grml-live
+++ b/grml-live
@@ -59,6 +59,7 @@ Usage: $PN [options, see as follows]
    -r <release_name>       release name
    -s <suite>              Debian suite; values: etch, lenny, squeeze, sid
    -t <template_directory> place of the templates
+   -T <tar_name>           unpack chroot tar archive before starting
    -u                      update existing chroot instead of rebuilding it from scratch
    -U <username>           arrange output to be owned by specified username
    -v <version_number>     specify version number of the release
@@ -151,7 +152,7 @@ umount_all() {
 
    # certain FAI versions sadly leave a ramdisk behind, so better safe than sorry
    if [ -x /usr/lib/fai/mkramdisk ] ; then
-     /usr/lib/fai/mkramdisk -u "$(realpath ${CHROOT_OUTPUT}/var/lib/dpkg)" >/dev/null 2>&1 || /bin/true
+     /usr/lib/fai/mkramdisk -u "$(readlink -f ${CHROOT_OUTPUT}/var/lib/dpkg)" >/dev/null 2>&1 || /bin/true
    fi
 
    umount "${CHROOT_OUTPUT}/grml-live/sources/" 2>/dev/null || /bin/true
@@ -196,7 +197,7 @@ trap umount_all EXIT
 
 # log output:
 # usage: log "string to log"
-log() { echo "$*" >> $LOGFILE ; }
+log() { [ -n "$LOGFILE" ] && echo "$*" >> $LOGFILE ; }
 
 # cut string at character number int = $1
 # usage: cut_string 5 "1234567890" will output "12345"
@@ -282,30 +283,15 @@ copy_addon_file() {
 }
 # }}}
 
-# read local (non-packaged) configuration {{{
-LOCAL_CONFIG=/etc/grml/grml-live.local
-if [ -r "$LOCAL_CONFIG" ] ; then
-   . $LOCAL_CONFIG
-else
-   LOCAL_CONFIG=''
-fi
-
-if [ -n "${GRML_LIVE_SOURCES:-}" ] ; then
-  eerror "Config variable \$GRML_LIVE_SOURCES is set. This variable has been deprecated."
-  ewarn  "Please set up ${GRML_FAI_CONFIG}/config/files/etc/apt/sources.list.d/* instead."
-  bailout 1
-fi
-# }}}
-
 # command line parsing {{{
-while getopts "a:C:c:d:D:g:i:I:o:r:s:t:U:v:AbBFnNquVz" opt; do
+while getopts "a:C:c:d:D:g:i:I:o:r:s:t:T:U:v:AbBFnNquVz" opt; do
   case "$opt" in
     a) ARCH="$OPTARG" ;;
     A) PACK_ARTIFACTS=1 ;;
     b) BUILD_ONLY=1 ;;
     B) BUILD_DIRTY=1 ;;
     c) CLASSES="$OPTARG" ;;
-    C) CONFIG="$OPTARG" ;;
+    C) GRML_LIVE_LOCAL_CONFIG="$OPTARG" ;;
     d) DATE="$OPTARG" ;;
     D) GRML_FAI_CONFIG="$OPTARG" ;;
     g) GRML_NAME="$OPTARG" ;;
@@ -318,6 +304,7 @@ while getopts "a:C:c:d:D:g:i:I:o:r:s:t:U:v:AbBFnNquVz" opt; do
     r) RELEASENAME="$OPTARG" ;;
     s) SUITE="$OPTARG" ;;
     t) TEMPLATE_DIRECTORY="$OPTARG";;
+    T) UNPACK_CHROOT="$(readlink -f $OPTARG)" ;;
     v) VERSION="$OPTARG" ;;
     F) FORCE=1 ;;
     u) UPDATE=1 ;;
@@ -330,10 +317,35 @@ done
 shift $(($OPTIND - 1))  # set ARGV to the first not parsed commandline parameter
 # }}}
 
+# read local (non-packaged) configuration {{{
+if [ -z "$GRML_LIVE_LOCAL_CONFIG" ]; then
+  if [ -r "/etc/grml/grml-live.local" ]; then
+    GRML_LIVE_LOCAL_CONFIG="/etc/grml/grml-live.local"
+  fi
+fi
+if [ -n "$GRML_LIVE_LOCAL_CONFIG" ]; then
+  if [ -r "$GRML_LIVE_LOCAL_CONFIG" ]; then
+    . $GRML_LIVE_LOCAL_CONFIG
+  else
+    eerror "Could not read specified local configuration file \"$GRML_LIVE_LOCAL_CONFIG\"."
+    bailout 1
+  fi
+  GRML_LIVE_LOCAL_CONFIG=$(readlink -f "$GRML_LIVE_LOCAL_CONFIG")
+else
+  GRML_LIVE_LOCAL_CONFIG=''
+fi
+
+if [ -n "${GRML_LIVE_SOURCES:-}" ] ; then
+  eerror "Config variable \$GRML_LIVE_SOURCES is set. This variable has been deprecated."
+  ewarn  "Please set up \${GRML_FAI_CONFIG}/config/files/etc/apt/sources.list.d/* instead."
+  bailout 1
+fi
+# }}}
+
 # assume sane defaults (if not set already) {{{
 [ -n "$ARCH" ]                    || ARCH="$(dpkg --print-architecture)"
 [ -n "$BOOT_METHOD" ]             || BOOT_METHOD='isolinux'
-[ -n "$CLASSES" ]                 || CLASSES="GRMLBASE,GRML_MEDIUM,$(echo ${ARCH} | tr 'a-z' 'A-Z')"
+[ -n "$CLASSES" ]                 || CLASSES="GRMLBASE,GRML_FULL,$(echo ${ARCH} | tr 'a-z' 'A-Z')"
 [ -n "$DATE" ]                    || DATE="$(date +%Y-%m-%d)"
 [ -n "$DISTRI_INFO" ]             || DISTRI_INFO='Grml - Live Linux for system administrators   '
 [ -n "$DISTRI_NAME" ]             || DISTRI_NAME="grml"
@@ -358,6 +370,7 @@ shift $(($OPTIND - 1))  # set ARGV to the first not parsed commandline parameter
 [ -n "$CHROOT_ARCHIVE" ]   || CHROOT_ARCHIVE="$OUTPUT/$(basename $CHROOT_OUTPUT).tgz"
 [ -n "$ISO_OUTPUT" ]       || ISO_OUTPUT="$OUTPUT/grml_isos"
 [ -n "$LOG_OUTPUT" ]       || LOG_OUTPUT="$OUTPUT/grml_logs"
+[ -n "$REPORTS" ]          || REPORTS="${LOG_OUTPUT}/reports/"
 # }}}
 
 # some misc checks before executing FAI {{{
@@ -391,10 +404,10 @@ if [ -z "$FORCE" ] ; then
    echo "${PN} [${GRML_LIVE_VERSION}]: check your configuration (or use -F to force execution):"
    echo
    echo "  FAI classes:       $CLASSES"
-   [ -r "$LOCAL_CONFIG" ]        && echo "  Local config:      /etc/grml/grml-live.local"
-   [ -n "$CONFIG" ]              && echo "  Configuration:     $CONFIG"
+   [ -n "$GRML_LIVE_LOCAL_CONFIG" ] && echo "  Configuration:     $GRML_LIVE_LOCAL_CONFIG"
    [ -n "$GRML_FAI_CONFIG" ]     && echo "  Config directory:  $GRML_FAI_CONFIG"
    echo "  main directory:    $OUTPUT"
+   [ -n "$UNPACK_CHROOT" ]       && echo "  Chroot from:       $UNPACK_CHROOT"
    [ -n "$CHROOT_OUTPUT" ]       && echo "  Chroot target:     $CHROOT_OUTPUT"
    [ -n "$BUILD_OUTPUT" ]        && echo "  Build target:      $BUILD_OUTPUT"
    [ -n "$ISO_OUTPUT" ]          && echo "  ISO target:        $ISO_OUTPUT"
@@ -444,7 +457,6 @@ if [ -n "${PACK_ARTIFACTS}" ]; then
   [ -n "${BUILD_OUTPUT}"   -a -d "${BUILD_OUTPUT}"   ] && rm -r "${BUILD_OUTPUT}"
   [ -n "${ISO_OUTPUT}"     -a -d "${ISO_OUTPUT}"     ] && rm -r "${ISO_OUTPUT}"
   [ -n "${LOG_OUTPUT}"     -a -d "${LOG_OUTPUT}"     ] && rm -r "${LOG_OUTPUT}"
-  [ -n "${CHROOT_ARCHIVE}" -a -f "${CHROOT_ARCHIVE}" ] && rm "${CHROOT_ARCHIVE}"
 fi
 # }}}
 
@@ -492,15 +504,34 @@ fi
 start_seconds=$(cut -d . -f 1 /proc/uptime)
 log "------------------------------------------------------------------------------"
 log "Starting grml-live [${GRML_LIVE_VERSION}] run on $(date)"
-if [ -n "$LOCAL_CONFIG" ]; then
-  log "Using local config file: $LOCAL_CONFIG"
-fi
+log "Using local config file: $GRML_LIVE_LOCAL_CONFIG"
 log "Executed grml-live command line:"
 log "$CMDLINE"
 
 einfo "Logging actions to logfile $LOGFILE"
 # }}}
 
+# unpack chroot {{{
+if [ -n "${UNPACK_CHROOT}" ]; then
+  log "Unpacking chroot from ${UNPACK_CHROOT}"
+  einfo "Unpacking chroot from ${UNPACK_CHROOT}"
+  [ -d "$CHROOT_OUTPUT" ] || mkdir -p "${CHROOT_OUTPUT}"
+  tar -xf "${UNPACK_CHROOT}" -C "${CHROOT_OUTPUT}/" --strip-components 1 ; RC=$?
+  if [ "$RC" != 0 ] ; then
+    eend 1
+    bailout 1
+  fi
+  eend 0
+fi
+# }}}
+
+# cleanup CHROOT_ARCHIVE now {{{
+if [ -n "${PACK_ARTIFACTS}" ]; then
+  # can't do this earlier, as UNPACK_CHROOT might point to CHROOT_ARCHIVE
+  [ -n "${CHROOT_ARCHIVE}" -a -f "${CHROOT_ARCHIVE}" ] && rm "${CHROOT_ARCHIVE}"
+fi
+# }}}
+
 # on-the-fly configuration {{{
 if [ -n "$FAI_DEBOOTSTRAP" ] ; then
   sed "s#^FAI_DEBOOTSTRAP=.*#FAI_DEBOOTSTRAP=\"$FAI_DEBOOTSTRAP\"#" "$NFSROOT_CONF" | sponge "$NFSROOT_CONF"
@@ -514,7 +545,7 @@ case $SUITE in
 esac
 export SUITE # make sure it's available in FAI scripts
 
-for file in "$LIVE_CONF" "$CONFIG" "$LOCAL_CONFIG" "$NFSROOT_CONF" ; do
+for file in "$LIVE_CONF" "$GRML_LIVE_LOCAL_CONFIG" "$NFSROOT_CONF" ; do
     if [ -n "$file" ] ; then
        sed "s|^FAI_DEBOOTSTRAP=\"[a-z]* |FAI_DEBOOTSTRAP=\"$SUITE |" "$file" | sponge "$file"
     fi
@@ -594,8 +625,8 @@ else
       echo force-unsafe-io > "$CHROOT_OUTPUT/etc/dpkg/dpkg.cfg.d/unsafe-io"
 
       log "Executed FAI command line:"
-      log "BUILD_ONLY=$BUILD_ONLY BOOTSTRAP_ONLY=$BOOTSTRAP_ONLY fai $VERBOSE -C $GRML_FAI_CONFIG -s file:///$GRML_FAI_CONFIG/config -c$CLASSES -u $HOSTNAME $FAI_ACTION $CHROOT_OUTPUT $FAI_ARGS"
-      BUILD_ONLY="$BUILD_ONLY" BOOTSTRAP_ONLY="$BOOTSTRAP_ONLY" fai $VERBOSE \
+      log "BUILD_ONLY=$BUILD_ONLY BOOTSTRAP_ONLY=$BOOTSTRAP_ONLY GRML_LIVE_LOCAL_CONFIG=$GRML_LIVE_LOCAL_CONFIG fai $VERBOSE -C $GRML_FAI_CONFIG -s file:///$GRML_FAI_CONFIG/config -c$CLASSES -u $HOSTNAME $FAI_ACTION $CHROOT_OUTPUT $FAI_ARGS"
+      BUILD_ONLY="$BUILD_ONLY" BOOTSTRAP_ONLY="$BOOTSTRAP_ONLY" GRML_LIVE_LOCAL_CONFIG="$GRML_LIVE_LOCAL_CONFIG" fai $VERBOSE \
                   -C "$GRML_FAI_CONFIG" -s "file:///$GRML_FAI_CONFIG/config" -c"$CLASSES" \
                   -u "$HOSTNAME" "$FAI_ACTION" "$CHROOT_OUTPUT" $FAI_ARGS | tee -a $LOGFILE
       RC="$PIPESTATUS" # notice: bash-only
@@ -631,18 +662,18 @@ else
       # move fai logs into grml_logs directory
       mkdir -p "$LOG_OUTPUT"/fai/
       cp -r "$CHROOT_OUTPUT"/var/log/fai/"$HOSTNAME"/last/* "$LOG_OUTPUT"/fai/
+      rm -rf "$CHROOT_OUTPUT"/var/log/fai
+      # copy fai package list
+      cp "$CHROOT_OUTPUT"/var/log/install_packages.list "$LOG_OUTPUT"/fai/
+      # fixup owners
       chown root:adm "$LOG_OUTPUT"/fai/*
       chmod 664 "$LOG_OUTPUT"/fai/*
-      rm -rf "$CHROOT_OUTPUT"/var/log/fai
-
-      # Remove all FAI logs from chroot if class RELEASE is used:
-      rm -f "$CHROOT_OUTPUT"/var/log/install_packages.list
 
       umount_all
 
       # notice: 'fai dirinstall' does not seem to exit appropriate, so:
       ERROR=''
-      CHECKLOG=/var/log/fai/$HOSTNAME/last
+      CHECKLOG="$LOG_OUTPUT"/fai/
       if [ -r "$CHECKLOG/software.log" ] ; then
          # 1 errors during executing of commands
          grep 'dpkg: error processing' $CHECKLOG/software.log >> $LOGFILE && ERROR=1
@@ -666,30 +697,84 @@ else
          log "Finished execution of stage 'fai dirinstall' [$(date)]"
          einfo "Finished execution of stage 'fai dirinstall'"
       fi
-
-      einfo "Find FAI build logs at $(readlink -f /var/log/fai/$HOSTNAME/last)"
-      log   "Find FAI build logs at $(readlink -f /var/log/fai/$HOSTNAME/last)"
-      eend 0
    fi
 fi # BUILD_DIRTY?
 # }}}
 
 # package validator {{{
 CHECKLOG=/var/log/fai/$HOSTNAME/last
-# package validator
-if [ -r "$CHECKLOG/package_errors.log" ] && grep -q '[a-z]' "$CHECKLOG/package_errors.log" ; then
+if [ -r "$CHECKLOG/dpkg.selections" ] ; then
+  package_count=$(wc -l "$CHECKLOG/dpkg.selections" | awk '{print $1}')
+else
+  package_count="unknown"
+fi
 
-   if [ -n "$EXIT_ON_MISSING_PACKAGES" -a -z "$BUILD_DIRTY" ] ; then
-      eerror "The following packages were requested for installation but could not be processed:"
-      cat $CHECKLOG/package_errors.log
-      eerror "... exiting as requested via \$EXIT_ON_MISSING_PACKAGES."
-      eend 1
-      bailout 13
-   else
-      ewarn "The following packages were requested for installation but could not be processed:"
-      cat $CHECKLOG/package_errors.log
-      eend 0
-   fi
+mkdir -p "$REPORTS"
+REPORT_MISSING_PACKAGES="${REPORTS}/TEST-MissingPackages.xml"
+
+# check for missing packages
+if ! [ -s "$CHECKLOG/package_errors.log" ] ; then
+  einfo "No missing packages found, generating empty junit report."
+
+  cat > "${REPORT_MISSING_PACKAGES}" << EOF
+<?xml version="1.0" encoding="UTF-8"?>
+<testsuite name="grml-live-missing-packages" tests="${package_count}" time="1" failures="0" errors="0" skipped="0" assertions="0">
+  <testcase name="test_missing_packages" time="0" assertions="0">
+  </testcase>
+  <system-out>
+  </system-out>
+  <system-err>
+  </system-err>
+</testsuite>
+EOF
+  eend 0
+else
+  einfo "Missing packages found, generating junit report."
+
+  if [ -r "$CHECKLOG/package_errors.log" ] ; then
+    package_errors=$(wc -l "$CHECKLOG/package_errors.log" | awk '{print $1}')
+  else
+    package_errors="unknown"
+  fi
+
+  mkdir -p "$REPORTS"
+  REPORT_MISSING_PACKAGES="${REPORTS}/TEST-MissingPackages.xml"
+
+  cat > "${REPORT_MISSING_PACKAGES}" << EOF
+<?xml version="1.0" encoding="UTF-8"?>
+<testsuite name="grml-live-missing-packages" tests="${package_count}" time="1" failures="${package_errors}" errors="${package_errors}" skipped="0" assertions="0">
+EOF
+
+  for package in $(awk '{print $5}' "${CHECKLOG}/package_errors.log" | sed 's/\.$//') ; do
+    cat >> "${REPORT_MISSING_PACKAGES}" << EOF
+  <testcase name="test_missing_packages_${package}" time="0" assertions="0">
+    <failure type="RuntimeError" message="Package ${package} is missing">
+Package $package is missing in chroot
+  </failure>
+  </testcase>
+EOF
+  done
+
+  cat >> "${REPORT_MISSING_PACKAGES}" << EOF
+  <system-out>
+  </system-out>
+  <system-err>
+  </system-err>
+</testsuite>
+EOF
+  eend 0
+
+  if [ -n "$EXIT_ON_MISSING_PACKAGES" -a -z "$BUILD_DIRTY" ] ; then
+    eerror "The following packages were requested for installation but could not be processed:"
+    cat "$CHECKLOG/package_errors.log"
+    eerror "... exiting as requested via \$EXIT_ON_MISSING_PACKAGES."
+    eend 1
+    bailout 13
+  else
+    ewarn "The following packages were requested for installation but could not be processed:"
+    cat "$CHECKLOG/package_errors.log"
+    eend 0
+  fi
 fi
 # }}}
 
@@ -793,27 +878,12 @@ if [ "$ARCH" = i386 ] || [ "$ARCH" = amd64 ] ; then
        fi
        cp ${TEMPLATE_DIRECTORY}/boot/grub/* "$BUILD_OUTPUT"/boot/grub/
 
-       if [ -e ${TEMPLATE_DIRECTORY}/compat/grub/linux.mod ]; then
-         cp "${TEMPLATE_DIRECTORY}"/compat/grub/* "${BUILD_OUTPUT}"/boot/grub/
-       else
-         if ! which "grub-mkimage" >/dev/null 2>&1 ; then
-           log   "grub-mkimage not found, skipping Grub step therefore." ; eend 0
-           ewarn "grub-mkimage not found, skipping Grub step therefore."
-           ewarn "Please install grub-pc-bin or grub-common >= 1.98+20100804-14." ; eend 0
-         elif ! grub-mkimage --help | grep -q -- --format ; then
-           log   "grub-mkimage does not support --format=i386-pc, skipping Grub step therefore." ; eend 0
-           ewarn "grub-mkimage does not support --format=i386-pc, skipping Grub step therefore."
-           ewarn "Please install grub-common >= 1.98+20100804-14 or grub-pc-bin." ; eend 0
-         else
-           # copy system grub files if grml-live-compat is not installed
-           cp -a /usr/lib/grub/*-pc/*.mod "${BUILD_OUTPUT}"/boot/grub/
-           cp -a /usr/lib/grub/*-pc/*.o "${BUILD_OUTPUT}"/boot/grub/
-           cp -a /usr/lib/grub/*-pc/*.lst "${BUILD_OUTPUT}"/boot/grub/
-           cp -a /usr/share/grub/ascii.pf2 "${BUILD_OUTPUT}"/boot/grub/
-           grub-mkimage -d /usr/lib/grub/*-pc -o \
-             "${BUILD_OUTPUT}/boot/grub/core.img" biosdisk iso9660 --format=i386-pc
-         fi
-       fi
+       # copy grub files from target
+       cp -a "${CHROOT_OUTPUT}"/usr/lib/grub/*-pc/*.mod "${BUILD_OUTPUT}"/boot/grub/
+       cp -a "${CHROOT_OUTPUT}"/usr/lib/grub/*-pc/*.o "${BUILD_OUTPUT}"/boot/grub/
+       cp -a "${CHROOT_OUTPUT}"/usr/lib/grub/*-pc/*.lst "${BUILD_OUTPUT}"/boot/grub/
+       cp -a "${CHROOT_OUTPUT}"/usr/share/grub/ascii.pf2 "${BUILD_OUTPUT}"/boot/grub/
+       cp -a "${CHROOT_OUTPUT}"/boot/grub/core.img "${BUILD_OUTPUT}"/boot/grub/
 
        if ! [ -d "${TEMPLATE_DIRECTORY}"/GRML ] ; then
           log    "Error: ${TEMPLATE_DIRECTORY}/GRML does not exist. Exiting."
@@ -1106,17 +1176,63 @@ else
       einfo "Forcing rebuild of ISO because files on ISO have been modified."
    fi
 
-   # support mkisofs as well as genisoimage
-   if which mkisofs >/dev/null 2>&1; then
+   # support xorriso as well mkisofs and genisoimage
+   if which xorriso >/dev/null 2>&1 ; then
+      MKISOFS='xorriso -as mkisofs'
+    elif which mkisofs >/dev/null 2>&1; then
       MKISOFS='mkisofs'
    elif which genisoimage >/dev/null 2>&1; then
       MKISOFS='genisoimage'
    else
-      log    "Error: neither mkisofs nor genisoimage available - can not create ISO."
-      eerror "Error: neither mkisofs nor genisoimage available - can not create ISO." ; eend 1
+      log    "Error: neither xorriso nor mkisofs nor genisoimage available - can not create ISO."
+      eerror "Error: neither xorriso nor mkisofs nor genisoimage available - can not create ISO." ; eend 1
       bailout
    fi
 
+   case "$ARCH" in
+     amd64)
+       # using -eltorito-alt-boot is limited to xorriso for now
+       case "$MKISOFS" in
+         xorriso*)
+           einfo "Using xorriso for ISO generation." ;  eend 0
+           eindent
+
+           if ! dpkg --compare-versions $(dpkg-query -W -f='${Version}\n' xorriso 2>/dev/null) gt-nl 1.1.6-1 ; then
+             log   "Disabling (U)EFI boot support since xorriso version is not recent enough."
+             ewarn "Disabling (U)EFI boot support since xorriso version is not recent enough." ; eend 0
+           else
+             log   "xorriso with -eltorito-alt-boot present, enabling (U)EFI boot support."
+             einfo "xorriso with -eltorito-alt-boot present, enabling (U)EFI boot support." ; eend 0
+
+             if [ -r "${CHROOT_OUTPUT}/var/lib/grml_live_efi.img" ] ; then
+               einfo "Found /var/lib/grml_live_efi.img - moving to /boot/efi.img for ISO."
+               log   "Found /var/lib/grml_live_efi.img - moving to /boot/efi.img for ISO."
+               mv "${CHROOT_OUTPUT}/var/lib/grml_live_efi.img" "${BUILD_OUTPUT}/boot/efi.img"
+               eend $?
+             fi
+
+             if [ -r "${CHROOT_OUTPUT}/var/lib/grml_live_bootx64.efi" ] ; then
+               einfo "Found /var/lib/grml_live_bootx64.efi - moving to /efi/boot/bootx64.efi for ISO"
+               log   "Found /var/lib/grml_live_bootx64.efi - moving to /efi/boot/bootx64.efi for ISO"
+               mkdir -p "${BUILD_OUTPUT}/efi/boot/"
+               mv "${CHROOT_OUTPUT}/var/lib/grml_live_bootx64.efi" "${BUILD_OUTPUT}/efi/boot/bootx64.efi"
+               eend $?
+             fi
+
+             if [ -r "${BUILD_OUTPUT}"/boot/efi.img ] ; then
+               einfo "/boot/efi.img found and amd64 architecture present, extending boot arguments."
+               log   "/boot/efi.img found and amd64 architecture present, extending boot arguments."
+               BOOT_ARGS="$BOOT_ARGS -boot-info-table -eltorito-alt-boot -e boot/efi.img -no-emul-boot"
+               eend $?
+             fi
+           fi
+
+           eoutdent
+           ;;
+       esac
+       ;;
+   esac
+
    CURRENT_DIR=$(pwd)
    if cd "$BUILD_OUTPUT" ; then
       if [ "$BOOT_METHOD" = "grub2" ]; then
@@ -1127,7 +1243,7 @@ else
             dd of=boot/grub/toriboot.bin conv=notrunc 2>/dev/null
       fi
       log "$MKISOFS -V '${GRML_NAME} ${VERSION}' -publisher 'grml-live | grml.org' -l -r -J $BOOT_ARGS -o ${ISO_OUTPUT}/${ISO_NAME} ."
-      "$MKISOFS" -V "${GRML_NAME} ${VERSION}" -publisher 'grml-live | grml.org' \
+      $MKISOFS -V "${GRML_NAME} ${VERSION}" -publisher 'grml-live | grml.org' \
               -l -r -J $BOOT_ARGS -no-pad \
               -o "${ISO_OUTPUT}/${ISO_NAME}" . ; RC=$?
       # both of these need core.img there, so it’s easier to write it here
@@ -1149,28 +1265,10 @@ else
          log   "Skipping creation of hybrid ISO file as requested via HYBRID_METHOD=disable"
          einfo "Skipping creation of hybrid ISO file as requested via HYBRID_METHOD=disable"
          eend 0
-      # use isohybrid only on request
-      elif [ "$HYBRID_METHOD" = "isohybrid" ] ; then
-         if ! which isohybrid >/dev/null 2>&1 ; then
-           bailout 12 "isohybrid binary not found - please install syslinux/syslinux-common"
-         else
-           log "Creating hybrid ISO file with isohybrid method"
-           einfo "Creating hybrid ISO file with isohybrid method"
-           # Notes for consideration:
-           # "-entry 4 -type 1c"
-           # * using 4 as the partition number is supposed to help with BIOSes
-           #   that only support USB-Zip boot
-           # * using 1c (i.e. hidden FAT32 LBA), instead of the default 0x17
-           #   (hidden NTFS, IIRC), as the partition type is sometimes needed
-           #   to get the BIOS even look at the partition created by isohybrid
-           isohybrid "${ISO_OUTPUT}/${ISO_NAME}"
-           eend $?
-         fi
-      # by default use our manifold boot method:
-      else
+      elif [ "$HYBRID_METHOD" = "manifold" ] ; then
          # isoinfo is part of both mkisofs and genisoimage so we're good
          bootoff=$(isoinfo -l -i "${ISO_OUTPUT}/${ISO_NAME}" | \
-           sed -n '/^.*\[ *\([0-9]*\)[] ].* ISOLINUX.BIN;1 *$/s//\1/p')
+           sed -n '/^.*\[ *\([0-9]*\)[] ].* ISOLINUX.BIN[;1]* *$/s//\1/p')
          if ! [ -r boot/grub/core.img ] ; then
            ewarn "boot/grub/core.img not found, not creating manifold boot ISO file"
          elif [ "${bootoff:-0}" -lt 1 ] ; then
@@ -1188,6 +1286,29 @@ else
            fi | dd of="${ISO_OUTPUT}/${ISO_NAME}" conv=notrunc 2>/dev/null
            eend $?
          fi
+      # use isohybrid as default
+      else
+         if ! which isohybrid >/dev/null 2>&1 ; then
+           bailout 12 "isohybrid binary not found - please install syslinux/syslinux-common"
+         else
+           log   "Creating hybrid ISO file with isohybrid method"
+           einfo "Creating hybrid ISO file with isohybrid method"
+           # Notes for consideration:
+           # "-entry 4 -type 1c"
+           # * using 4 as the partition number is supposed to help with BIOSes
+           #   that only support USB-Zip boot
+           # * using 1c (i.e. hidden FAT32 LBA), instead of the default 0x17
+           #   (hidden NTFS, IIRC), as the partition type is sometimes needed
+           #   to get the BIOS even look at the partition created by isohybrid
+           if isohybrid --help | grep -q -- --uefi ; then
+             einfo "Detected uefi support for isohybrid, enabling."
+             ISOHYBRID_OPTIONS=--uefi
+           fi
+
+           log "isohybrid $ISOHYBRID_OPTIONS ${ISO_OUTPUT}/${ISO_NAME}"
+           isohybrid $ISOHYBRID_OPTIONS "${ISO_OUTPUT}/${ISO_NAME}"
+           eend $?
+         fi
       fi
 
       # generate md5sum and sha1sum of ISO if we are using class 'RELEASE':